﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.SelfHost;

namespace HalMediaType
{
    class Program
    {
        static void Main(string[] args)
        {
            var config = new HttpSelfHostConfiguration("http://localhost:8091");

            config.Routes.MapHttpRoute(
                "products", "api/products/{id}",
                new 
                { 
                    controller = "ProductCatalog",
                    id = RouteParameter.Optional 
                });

            config.Routes.MapHttpRoute(
               "cart", "api/cart/{id}",
               new
               {
                   controller = "Cart",
                   id = RouteParameter.Optional
               });

            config.Routes.MapHttpRoute(
                "API Default", "api/{controller}/{id}",
                new { id = RouteParameter.Optional });

            config.Formatters.Clear();
            config.Formatters.Add(new HalXmlMediaTypeFormatter());

            using (HttpSelfHostServer server = new HttpSelfHostServer(config))
            {
                server.OpenAsync().Wait();
                Console.WriteLine("Press Enter to quit.");
                Console.ReadLine();
            }
        }
    }
}
